/***/
var APIBASE = 'http://popeye.hotflix.me/';
//

$.inject = function(collection, accumulator, iterator, context) {
	$.each(collection, function(index, value){
		accumulator = iterator.call(context, accumulator, index, value)
	})
	return accumulator
}


window.DEVICE = window.DEVICE || '-'

function ContentDataSource(options) {
	this.lang = options.lang || 'en'
	this.cacheLifeTime = options.cacheLifeTime || 24*3600*1000
	this.onLoadStart = options.onLoadStart 	|| $.noop
	this.onLoadEnd   = options.onLoadEnd 		|| $.noop
	this.onError     = options.onError 		|| $.noop
	this.onProgress  = options.onProgress 	|| $.noop
	this.onContentReceived = options.onContentReceived || $.noop
	var onError = this.onError
	$(document).ajaxError(function(ev, xhr, settings, ex) {
		onError(ex || xhr.responseText || settings.url, 'ajaxError')
	})
}

ContentDataSource.prototype.setLanguage = function(l) {
	this.lang = l
}

ContentDataSource.prototype.getImageUrl = function(url) {
	return this.webRoot('i/c120x80') + url;
}

ContentDataSource.prototype.getContent = function() {
	if (LocalStorage.getItem('apiBaseUrl') != this.lang+":"+APIBASE) {
		console.log('Clean-up LocalStorage')
		LocalStorage.clear() // clenup previous data before update
	}
	
	// Check if there any fresh data in localStorage and return it if found
	var cache = LocalStorage.getItem('dataSourceCache_getContent')
	if (cache) {
		cache = JSON.parse(cache)
		// if found in cache && cache not empty && cache no expired 
		var itemsLoaded = $.inject(cache.content, 0, function(acc, ind, val) { return acc+val.length })
		if (cache && (itemsLoaded>0) && ((new Date().getTime() - cache.localTime) < this.cacheLifeTime) ) {
			this.onContentReceived.call(this, cache)
			return;
		}
	}
	
	var that = this
	this._loadRemoteContent(function(data) {
		LocalStorage.setItem('dataSourceCache_getContent', JSON.stringify(data))
		LocalStorage.setItem('apiBaseUrl', this.lang+":"+APIBASE) // used to check data consistency
		that.onContentReceived.call(that, data)
	})
}


ContentDataSource.prototype.webRoot = function(url) {
	return (window.device && window.device.version
			? APIBASE
			: 'http://'+location.host+'/')
		+ url
}

ContentDataSource.prototype._loadRemoteContent = function(callback) {
	var that = this;
	this.onLoadStart.call(null, 'getContent')
	
	$.getJSON( this.webRoot('api/androidSupport/content.json'),
		{ lang: this.lang, uuid: DEVICE, r: new Date().getTime() },
		function(data) {
			if (!data)
				return that.onError('connection_error', 'getContent')
				
			if (data.code > 0)
				return that.onError(data.message, 'getContent')
			
			
			if (!data.content)
				data.content = {free: [], paid: []}
			
			data.localTime = new Date().getTime()
			
			
			var t, i, l,
				totalImages = 0,
				loadedImages =0,
				previews = {};

			for (t in data.content)
				for (i=0, l=data.content[t].length; i<l; i++)
					previews[data.content[t][i].id] = true;
			
			that.gc(previews)
			

			for (t in data.content) {
				l=data.content[t].length
				totalImages += l
				for(i=0; i<l; i++) {
					(function() {
						var it = data.content[t][i],
							d = LocalStorage.getItem("preview" + it.id)
						if ( d ) { //image already loaded
							it.imageData = d
							previews[it.id] = true
							loadedImages++;
							return;
						}
						$.ajax({
							url: that.getImageUrl(it.preview),
							success: function(data, textStatus, xhr) {
								it.imageData = data
								LocalStorage.setItem("preview" + it.id, data)
								previews[it.id] = true
								loadedImages++
							},
							error: function(xhr, textStatus, errorThrown) {
								loadedImages++;
							},
							context: it,
							global: false
						})
					})()
				}
			}
			
			setTimeout(function() {
				that.onProgress.call(null, loadedImages, totalImages)
				if (loadedImages < totalImages) {
					setTimeout(arguments.callee, 300)
				} else {
					$.isFunction(callback) && callback.call(that, data)
					that.onLoadEnd.call(null, 'getContent')
				}
			}, 5)
			
		})// getJSON
}

// ids = {id1: true, id2: true, id3: true}
ContentDataSource.prototype.gc = function(ids) {
  console.log('Running garbage collection...')
  var n = 0,
    keys = LocalStorage.enumKeys()
  for (var i=0, l=keys.length; i<l; i++) {
    var v = keys[i]
    if (v.substr(0,7) != "preview") continue;
    var id = parseInt(v.substr(7))
    if (isNaN(id))
      continue
    if (typeof(ids[id]) == 'undefined') {
      LocalStorage.removeItem("preview"+id)
      n++
    }
  }
  console.log('Items evicted from storage: ' + n)
}

ContentDataSource.prototype.getWatchUrl = function(id, callback) {
	this.onLoadStart.call(null, 'getWatchUrl')
	var that = this
	$.post(this.webRoot('api/androidSupport/watch.json'), 
		{id: id, uuid: DEVICE, lang: this.lang, r: new Date().getTime()}, 
		function(data) {
			if (!data)
				return that.onError('connection_error', 'getWatchUrl')
				
			if (data.code > 0)
				return that.onError.call(null, data.message, 'getWatchUrl')
			
			that.onLoadEnd.call(null, 'getWatchUrl')
			$.isFunction(callback) && callback.call(that, data)
		}, 
		"json"
	)
}


