/**
* LocalStorage - simple exception-less wrapper around window.localStorage
* TODO: Handle read-only storage 
*/
var LocalStorage = {
	support: ('localStorage' in window),
	
	setItem: function(key, value) {
		try {
			this.support ? window.localStorage.setItem(key, value) : this.__localData[key] = value
		} catch (e) {
			console.log("Exception: " + e.message)
		}
	},
	
	getItem: function(key) {
		return this.support ? window.localStorage.getItem(key) : this.__localData[key]
	},
	
	removeItem: function(key) {
		if (this.support)
			return window.localStorage.removeItem(key)
		delete this.__localData[key]
	},
	
	clear: function() {
		this.support ? window.localStorage.clear() : this.__localData = {} 
	},
	
	/** 
	* This function not exists in the original window.localStorage
	* @return the list of localStorage key's available 
	*/
	enumKeys: function() {
		var r = [],
			l = this.support ? window.localStorage : this.__localData 
		for (i in l)
			if (typeof(l[i]) != 'function')
				r.push(i)
		return r
	},
	
	
	__localData: {}
}
console.log(LocalStorage.support ? "Using native localStorage" : "Using in-memory LocalStorage.__localData" )

